<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<databaseChangeLog xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
                   xmlns="http://www.liquibase.org/xml/ns/dbchangelog"
                   xsi:schemaLocation="http://www.liquibase.org/xml/ns/dbchangelog
                        http://www.liquibase.org/xml/ns/dbchangelog/dbchangelog-3.6.xsd">

    <changeSet id="create_user_table" author="Nataliia_Soloviova">
        <preConditions onFail="MARK_RAN">
            <not><tableExists tableName="user"/></not>
        </preConditions>
        <createTable tableName="user">
            <column name="id" type="binary(16)">
                <constraints primaryKey="true" nullable="false"/>
            </column>
            <column name="password" type="varchar(150)"/>
            <column name="first_name" type="varchar(50)">
                <constraints nullable="false"/>
            </column>
            <column name="enabled" type="boolean" defaultValueBoolean="true">
                <constraints nullable="false"/>
            </column>
            <column name="role_id" type="int"/>
        </createTable>
        <modifySql dbms="mysql">
            <append value="ENGINE=INNODB CHARSET=UTF8 COLLATE utf8_general_ci"/>
        </modifySql>
    </changeSet>

    <changeSet id="create_admin_table" author="Nataliia_Soloviova">
        <preConditions onFail="MARK_RAN">
            <not><tableExists tableName="admin"/></not>
        </preConditions>
        <createTable tableName="admin">
            <column name="id" type="binary(16)">
                <constraints primaryKey="true" foreignKeyName="fk_user_id_in_admin" references="user(id)"/>
            </column>
        </createTable>
        <modifySql dbms="mysql">
            <append value="ENGINE=INNODB CHARSET=UTF8 COLLATE utf8_general_ci"/>
        </modifySql>
    </changeSet>

    <changeSet id="create_client_table" author="Nataliia_Soloviova">
        <preConditions onFail="MARK_RAN">
            <not><tableExists tableName="client"/></not>
        </preConditions>
        <createTable tableName="client">
            <column name="id" type="binary(16)">
                <constraints primaryKey="true" foreignKeyName="fk_user_id_in_client" references="user(id)"/>
            </column>
            <column name="passport_id" type="varchar(50)">
                <constraints nullable="false" unique="true"/>
            </column>
        </createTable>
        <modifySql dbms="mysql">
            <append value="ENGINE=INNODB CHARSET=UTF8 COLLATE utf8_general_ci"/>
        </modifySql>
    </changeSet>

    <changeSet id="create_card_table" author="Nataliia_Soloviova">
        <preConditions onFail="MARK_RAN">
            <not><tableExists tableName="card"/></not>
        </preConditions>
        <createTable tableName="card">
            <column name="id" type="binary(16)">
                <constraints primaryKey="true" nullable="false"/>
            </column>
            <column name="number" type="varchar(16)">
                <constraints nullable="false"/>
            </column>
            <column name="enabled" type="boolean" defaultValueBoolean="true">
                <constraints nullable="false"/>
            </column>
        </createTable>
        <modifySql dbms="mysql">
            <append value="ENGINE=INNODB CHARSET=UTF8 COLLATE utf8_general_ci"/>
        </modifySql>
    </changeSet>

    <changeSet id="create_bill_table" author="Nataliia_Soloviova">
        <preConditions onFail="MARK_RAN">
            <not><tableExists tableName="bill"/></not>
        </preConditions>
        <createTable tableName="bill">
            <column name="id" type="binary(16)">
                <constraints primaryKey="true" nullable="false"/>
            </column>
            <column name="title" type="varchar(50)"/>
            <column name="balance" type="int" defaultValue="0">
                <constraints nullable="false"/>
            </column>
            <column name="enabled" type="boolean" defaultValueBoolean="true">
                <constraints nullable="false"/>
            </column>
            <column name="client_id" type="binary(16)">
                <constraints foreignKeyName="fk_client_id_in_bill" references="client(id)"/>
            </column>
        </createTable>
        <modifySql dbms="mysql">
            <append value="ENGINE=INNODB CHARSET=UTF8 COLLATE utf8_general_ci"/>
        </modifySql>
    </changeSet>

    <changeSet id="create_payment_table" author="Nataliia_Soloviova">
        <preConditions onFail="MARK_RAN">
            <not><tableExists tableName="payment"/></not>
        </preConditions>
        <createTable tableName="payment">
            <column name="id" type="binary(16)">
                <constraints primaryKey="true" nullable="false"/>
            </column>
            <column name="date" type="timestamp">
                <constraints nullable="false"/>
            </column>
            <column name="status_id" type="int">
                <constraints nullable="false"/>
            </column>
            <column name="purpose" type="varchar(250)"/>
            <column name="amount" type="int">
                <constraints nullable="false"/>
            </column>
            <column name="bill_id" type="binary(16)">
                <constraints foreignKeyName="fk_bill_id_in_payment" references="bill(id)"/>
            </column>
        </createTable>
        <modifySql dbms="mysql">
            <append value="ENGINE=INNODB CHARSET=UTF8 COLLATE utf8_general_ci"/>
        </modifySql>
    </changeSet>

    <changeSet id="create_request_table" author="Nataliia_Soloviova">
        <preConditions onFail="MARK_RAN">
            <not><tableExists tableName="request"/></not>
        </preConditions>
        <createTable tableName="request">
            <column name="id" type="binary(16)">
                <constraints primaryKey="true" nullable="false"/>
            </column>
        </createTable>
        <modifySql dbms="mysql">
            <append value="ENGINE=INNODB CHARSET=UTF8 COLLATE utf8_general_ci"/>
        </modifySql>
    </changeSet>

    <changeSet id="create_response_table" author="Nataliia_Soloviova">
        <preConditions onFail="MARK_RAN">
            <not><tableExists tableName="response"/></not>
        </preConditions>
        <createTable tableName="response">
            <column name="id" type="binary(16)">
                <constraints primaryKey="true" nullable="false"/>
            </column>
        </createTable>
        <modifySql dbms="mysql">
            <append value="ENGINE=INNODB CHARSET=UTF8 COLLATE utf8_general_ci"/>
        </modifySql>
    </changeSet>

</databaseChangeLog>